<?xml version="1.0" encoding="utf-8"?>
<res class="ShaderProgram" class="ShaderProgram" path="Res://ForceField/ForceField.shader" Type="glsl" VertexShader="#version 450&#10;&#10;layout(binding = 0, std140) uniform UBO&#10;{&#10;    mat4 u_WorldMatrix;&#10;    mat4 u_ViewProjMatrix;&#10;} vs_ubo;&#10;&#10;layout(location = 0) in vec3 a_Position;&#10;layout(location = 1) out vec3 v_Normal;&#10;layout(location = 1) in vec3 a_Normal;&#10;layout(location = 3) out vec2 v_UV;&#10;layout(location = 3) in vec2 a_UV;&#10;&#10;void main()&#10;{&#10;    vec4 position = vs_ubo.u_WorldMatrix * vec4(a_Position, 1.0);&#10;    position = vs_ubo.u_ViewProjMatrix * position;&#10;    gl_Position = position;&#10;    v_Normal = normalize(vec3((vs_ubo.u_WorldMatrix * vec4(a_Normal, 0.0)).xyz));&#10;    v_UV = a_UV;&#10;}&#10;&#10;" FragmentShader="#version 450&#10;&#10;layout(binding = 0, std140) uniform UBO&#10;{&#10;    float u_Time;&#10;    vec3 u_CameraDirection;&#10;} fs_ubo;&#10;&#10;layout(binding = 1) uniform sampler2D Diffuse;&#10;&#10;layout(location = 3) in vec2 v_UV;&#10;layout(location = 1) in vec3 v_Normal;&#10;layout(location = 0) out vec4 o_FragColor;&#10;&#10;vec3 SRgbToLinear(vec3 srgbIn)&#10;{&#10;    return pow(srgbIn, vec3(2.2000000476837158203125));&#10;}&#10;&#10;vec3 LinearToSRgb(vec3 linearIn)&#10;{&#10;    return pow(linearIn, vec3(0.4545454680919647216796875));&#10;}&#10;&#10;void main()&#10;{&#10;    float Float_24 = 0.0030000000260770320892333984375;&#10;    vec4 Color_30_Value = vec4(0.0445530004799365997314453125, 0.6253449916839599609375, 0.694081008434295654296875, 1.0);&#10;    float Float_36 = -1.0;&#10;    float Float_40 = 1.0;&#10;    float Float_42 = 0.07998000085353851318359375;&#10;    float Float_45 = 1.79999005794525146484375;&#10;    float Float_47 = 0.20000000298023223876953125;&#10;    float Float_50 = 1.29999005794525146484375;&#10;    float Multiplication_29 = fs_ubo.u_Time * Float_24;&#10;    float Multiplication_33 = fs_ubo.u_Time * Float_47;&#10;    vec2 Substraction_32 = v_UV - vec2(Multiplication_29);&#10;    float Sin_39 = sin(Multiplication_33);&#10;    vec3 Multiplication_38 = fs_ubo.u_CameraDirection * Float_36;&#10;    float Addition_49 = Sin_39 + Float_50;&#10;    vec4 Diffuse_Color = texture(Diffuse, Substraction_32);&#10;    vec3 param = Diffuse_Color.xyz;&#10;    vec3 _100 = SRgbToLinear(param);&#10;    Diffuse_Color = vec4(_100.x, _100.y, _100.z, Diffuse_Color.w);&#10;    vec3 Multiplication_31 = Diffuse_Color.xyz * Color_30_Value.xyz;&#10;    float DotProduct_35 = dot(v_Normal, Multiplication_38);&#10;    float Substraction_41 = Float_40 - DotProduct_35;&#10;    float Pow_44 = pow(Substraction_41, Float_45);&#10;    float Multiplication_37 = Diffuse_Color.z * Pow_44;&#10;    float Multiplication_48 = Multiplication_37 * Addition_49;&#10;    float Max_43 = max(Multiplication_48, Float_42);&#10;    vec3 _BaseColor = Multiplication_31;&#10;    float _Opacity = Max_43;&#10;    float _Metalic = 0.20000000298023223876953125;&#10;    float _PerceptualRoughness = 0.5;&#10;    vec3 param_1 = _BaseColor;&#10;    o_FragColor = vec4(LinearToSRgb(param_1), _Opacity);&#10;}&#10;&#10;" Graph="{&#10;    &quot;connections&quot;: [&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{f6e03554-e405-4a57-85e1-78bc28d61dcf}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{62e6c141-bf91-4cbc-b7b8-caec7ce7fb37}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;in_id&quot;: &quot;{956eb066-81f3-4d4e-a7da-382f92f9d30f}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{054f821c-ee3b-44dd-8c37-747ae31fac25}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec3&quot;,&#10;                    &quot;name&quot;: &quot;vec3&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{62e6c141-bf91-4cbc-b7b8-caec7ce7fb37}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{0cbbbdca-0fdf-4a69-ba2b-f19cbc98a314}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{5d8ecb83-f91c-4259-8470-901f2d90307f}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{a7c27fcd-5a95-4ba8-a3cd-450c693e71c7}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;b&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{a7c27fcd-5a95-4ba8-a3cd-450c693e71c7}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{a3b3fcfa-b806-4332-b6a1-84aacbf655c0}&quot;,&#10;            &quot;out_index&quot;: 3&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{76e82ae3-9624-47fc-887b-25d4bd4a3113}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{df6c73d7-928d-46f9-bd3a-4d68b54fc2c2}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;in_id&quot;: &quot;{956eb066-81f3-4d4e-a7da-382f92f9d30f}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{76e82ae3-9624-47fc-887b-25d4bd4a3113}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec3&quot;,&#10;                    &quot;name&quot;: &quot;rgb&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{054f821c-ee3b-44dd-8c37-747ae31fac25}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{a3b3fcfa-b806-4332-b6a1-84aacbf655c0}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec2&quot;,&#10;                    &quot;name&quot;: &quot;vec2&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{49d3c855-330e-4ad1-9309-01ca7248310f}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{67f53743-8192-49fd-b0a4-867b47a90fdf}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{f6e03554-e405-4a57-85e1-78bc28d61dcf}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{f97063f9-06b9-4ac4-9d37-9b8c907edc28}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{4ea68102-4960-4d6e-88e0-b2b314ddb91d}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{2abc6b16-0c10-4c47-aa6a-cdfbda268438}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{a37c0d06-6bc2-44e2-8703-d5562556ff0c}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{1c2022de-b9a4-4732-b608-38ebd1b356cd}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{a37c0d06-6bc2-44e2-8703-d5562556ff0c}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{c70cbbce-b3e6-41e3-81de-f9f367cc88d2}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;in_id&quot;: &quot;{a3b3fcfa-b806-4332-b6a1-84aacbf655c0}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{49d3c855-330e-4ad1-9309-01ca7248310f}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{49d3c855-330e-4ad1-9309-01ca7248310f}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{4ea68102-4960-4d6e-88e0-b2b314ddb91d}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec3&quot;,&#10;                    &quot;name&quot;: &quot;rgb&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{054f821c-ee3b-44dd-8c37-747ae31fac25}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{218e2523-4f0f-4dde-9191-04a6a0061cf0}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{756ac28d-01f4-49fa-bf78-d47542e9bbad}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{f6e03554-e405-4a57-85e1-78bc28d61dcf}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec3&quot;,&#10;                    &quot;name&quot;: &quot;vec3&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{62e6c141-bf91-4cbc-b7b8-caec7ce7fb37}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{8b223442-17c9-4e62-980a-4675f2b10332}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{9e8b4cfc-6c88-4b77-9ba6-20acc603fe6e}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{8a327250-90e9-4d78-9033-38ce047b88b6}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{76e82ae3-9624-47fc-887b-25d4bd4a3113}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{5d8ecb83-f91c-4259-8470-901f2d90307f}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{756ac28d-01f4-49fa-bf78-d47542e9bbad}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{2f696eaa-c0d1-43c5-8453-9a8ea776385f}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{4ea68102-4960-4d6e-88e0-b2b314ddb91d}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{ba906846-7766-4e9c-9912-e0231560038e}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{9e8b4cfc-6c88-4b77-9ba6-20acc603fe6e}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{b739b7bb-a04c-4581-b217-f0230a5b8949}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{b739b7bb-a04c-4581-b217-f0230a5b8949}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{a37c0d06-6bc2-44e2-8703-d5562556ff0c}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{a7c27fcd-5a95-4ba8-a3cd-450c693e71c7}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{756ac28d-01f4-49fa-bf78-d47542e9bbad}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{0cbbbdca-0fdf-4a69-ba2b-f19cbc98a314}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{964b7b09-33c9-46cc-8651-4a58aa209913}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;A&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;vec3&quot;,&#10;                    &quot;name&quot;: &quot;vec3&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{0cbbbdca-0fdf-4a69-ba2b-f19cbc98a314}&quot;,&#10;            &quot;in_index&quot;: 0,&#10;            &quot;out_id&quot;: &quot;{57a77d9d-6b9c-4480-8e86-c3963a7cc1b8}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        },&#10;        {&#10;            &quot;converter&quot;: {&#10;                &quot;in&quot;: {&#10;                    &quot;id&quot;: &quot;any&quot;,&#10;                    &quot;name&quot;: &quot;B&quot;&#10;                },&#10;                &quot;out&quot;: {&#10;                    &quot;id&quot;: &quot;float&quot;,&#10;                    &quot;name&quot;: &quot;float&quot;&#10;                }&#10;            },&#10;            &quot;in_id&quot;: &quot;{5d8ecb83-f91c-4259-8470-901f2d90307f}&quot;,&#10;            &quot;in_index&quot;: 1,&#10;            &quot;out_id&quot;: &quot;{9e8b4cfc-6c88-4b77-9ba6-20acc603fe6e}&quot;,&#10;            &quot;out_index&quot;: 0&#10;        }&#10;    ],&#10;    &quot;nodes&quot;: [&#10;        {&#10;            &quot;id&quot;: &quot;{956eb066-81f3-4d4e-a7da-382f92f9d30f}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;ShaderTemplate&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: 659,&#10;                &quot;y&quot;: 522&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{67f53743-8192-49fd-b0a4-867b47a90fdf}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;VertexAttribute&quot;,&#10;                &quot;option&quot;: &quot;uv0&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -828,&#10;                &quot;y&quot;: 205&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{ba906846-7766-4e9c-9912-e0231560038e}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;0.003&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -927,&#10;                &quot;y&quot;: 399&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{2abc6b16-0c10-4c47-aa6a-cdfbda268438}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Shared&quot;,&#10;                &quot;option&quot;: &quot;u_Time&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -1022,&#10;                &quot;y&quot;: 297&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{a3b3fcfa-b806-4332-b6a1-84aacbf655c0}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;isParameter&quot;: &quot;true&quot;,&#10;                &quot;name&quot;: &quot;Texture&quot;,&#10;                &quot;texture&quot;: &quot;&quot;,&#10;                &quot;variableName&quot;: &quot;Diffuse&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -332,&#10;                &quot;y&quot;: 144&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{8b223442-17c9-4e62-980a-4675f2b10332}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;VertexAttribute&quot;,&#10;                &quot;option&quot;: &quot;normal&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -893,&#10;                &quot;y&quot;: 701&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{4ea68102-4960-4d6e-88e0-b2b314ddb91d}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -726,&#10;                &quot;y&quot;: 325&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{218e2523-4f0f-4dde-9191-04a6a0061cf0}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;color&quot;: &quot;0.243137 0.807843 0.847059 1 &quot;,&#10;                &quot;isParameter&quot;: &quot;false&quot;,&#10;                &quot;name&quot;: &quot;Color&quot;,&#10;                &quot;variableName&quot;: &quot;Color_30&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -323,&#10;                &quot;y&quot;: 378&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{054f821c-ee3b-44dd-8c37-747ae31fac25}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -24,&#10;                &quot;y&quot;: 367&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{a37c0d06-6bc2-44e2-8703-d5562556ff0c}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -278,&#10;                &quot;y&quot;: 907&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{49d3c855-330e-4ad1-9309-01ca7248310f}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Substraction&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -532,&#10;                &quot;y&quot;: 244&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{57a77d9d-6b9c-4480-8e86-c3963a7cc1b8}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Shared&quot;,&#10;                &quot;option&quot;: &quot;u_CameraDirection&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -1106,&#10;                &quot;y&quot;: 812&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{964b7b09-33c9-46cc-8651-4a58aa209913}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;-1.0&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -1007,&#10;                &quot;y&quot;: 894&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{62e6c141-bf91-4cbc-b7b8-caec7ce7fb37}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;DotProduct&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -624,&#10;                &quot;y&quot;: 716&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{a7c27fcd-5a95-4ba8-a3cd-450c693e71c7}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -29,&#10;                &quot;y&quot;: 556&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{b739b7bb-a04c-4581-b217-f0230a5b8949}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Sin&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -97,&#10;                &quot;y&quot;: 902&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{0cbbbdca-0fdf-4a69-ba2b-f19cbc98a314}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -789,&#10;                &quot;y&quot;: 830&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{f97063f9-06b9-4ac4-9d37-9b8c907edc28}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;1.0&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -666,&#10;                &quot;y&quot;: 609&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{f6e03554-e405-4a57-85e1-78bc28d61dcf}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Substraction&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -422,&#10;                &quot;y&quot;: 642&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{df6c73d7-928d-46f9-bd3a-4d68b54fc2c2}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;0.07998&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: 266,&#10;                &quot;y&quot;: 881&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{76e82ae3-9624-47fc-887b-25d4bd4a3113}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Max&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: 457,&#10;                &quot;y&quot;: 697&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{756ac28d-01f4-49fa-bf78-d47542e9bbad}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Pow&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -195,&#10;                &quot;y&quot;: 667&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{2f696eaa-c0d1-43c5-8453-9a8ea776385f}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;1.79999&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -452,&#10;                &quot;y&quot;: 800&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{c70cbbce-b3e6-41e3-81de-f9f367cc88d2}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Shared&quot;,&#10;                &quot;option&quot;: &quot;u_Time&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -576,&#10;                &quot;y&quot;: 905&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{1c2022de-b9a4-4732-b608-38ebd1b356cd}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;0.2&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -478,&#10;                &quot;y&quot;: 991&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{5d8ecb83-f91c-4259-8470-901f2d90307f}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Multiplication&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: 219,&#10;                &quot;y&quot;: 633&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{9e8b4cfc-6c88-4b77-9ba6-20acc603fe6e}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Addition&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: 39,&#10;                &quot;y&quot;: 927&#10;            }&#10;        },&#10;        {&#10;            &quot;id&quot;: &quot;{8a327250-90e9-4d78-9033-38ce047b88b6}&quot;,&#10;            &quot;model&quot;: {&#10;                &quot;name&quot;: &quot;Float&quot;,&#10;                &quot;number&quot;: &quot;1.29999&quot;&#10;            },&#10;            &quot;position&quot;: {&#10;                &quot;x&quot;: -141,&#10;                &quot;y&quot;: 986&#10;            }&#10;        }&#10;    ]&#10;}&#10;" CullMode="CULL_BACK" BlendMode="Transparent" />
